default:
  image: azul/zulu-openjdk-alpine:11-latest

before_script:
  - apk add git bash python3

variables:
  # Always shallow clone
  GIT_DEPTH: 5
  GRADLE: ./gradlew --console=plain --build-cache --gradle-user-home cache/

.gradle-cache:
  cache:
    key:
      files:
        - gradle/wrapper/gradle-wrapper.properties
    paths:
      - cache/caches/
      - cache/notifications/
      - cache/wrapper/

test-kieselstein:
  extends: .gradle-cache
  services:
    - name: postgres:16-alpine
      alias: db1
      variables:
        POSTGRES_DB: KIESELSTEIN
        POSTGRES_USER: postgres
        POSTGRES_PASSWORD: postgres
        POSTGRES_HOST_AUTH_METHOD: trust
    - name: postgres:16-alpine
      alias: db2
      variables:
        POSTGRES_DB: KIESELSTEIN_DOCUMENTS
        POSTGRES_USER: postgres
        POSTGRES_PASSWORD: postgres
        POSTGRES_HOST_AUTH_METHOD: trust
  variables:
    MAIN_DB_HOST: db1
    DOC_DB_HOST: db2
  script:
    - $GRADLE kieselstein-distpack:updateDatabase
    - $GRADLE kieselstein-server:configureWildfly
    - $GRADLE kieselstein-ejb:check
    - $GRADLE kieselstein-server:clean
    - $GRADLE kieselstein-server:configureWildfly
    - $GRADLE kieselstein-server:deployEar
    - $GRADLE kieselstein-server:launchWildfly
    - $GRADLE kieselstein-client:check
    - $GRADLE kieselstein-server:shutdownWildfly
  artifacts:
    when: always
    expire_in: 1 week
    paths:
      - kieselstein-*/build/jacoco.exec
      - kieselstein-*/build/test-results/test/**/TEST-*.xml
    reports:
      junit: kieselstein-*/build/test-results/test/**/TEST-*.xml

# TODO [2024-08-02] ek:
# GitLab currently only supports code-coverage using Cobertura's XML format.
# JaCoCo will be supported in the future https://gitlab.com/gitlab-org/gitlab/-/issues/227345
# in the meantime we convert our JaCoCo coverage reports to Cobertura.
# Should be removed when GitLab has implemented native JaCoCo support.
pages:
  extends: .gradle-cache
  needs:
    - test-kieselstein
  script:
    - $GRADLE classes
    - $GRADLE kieselstein-rest:enunciate
    - $GRADLE kieselstein-doc:buildDocs
    - git clone https://gitlab.com/haynes/jacoco2cobertura.git
    - 'python3 jacoco2cobertura/cover2cover.py kieselstein-doc/build/coverage/jacoco.xml $CI_PROJECT_DIR/kieselstein-client/src/main/java $CI_PROJECT_DIR/kieselstein-common/src/main/java $CI_PROJECT_DIR/kieselstein-ejb/src/main/java $CI_PROJECT_DIR/kieselstein-rest/src/main/java $CI_PROJECT_DIR/kieselstein-web/src/main/java > cobertura.xml'
  after_script:
    - mkdir -p public/$CI_COMMIT_BRANCH
    - mv kieselstein-doc/build/html public/$CI_COMMIT_BRANCH/dashboard
    - mv kieselstein-rest/build/enunciate/docs public/$CI_COMMIT_BRANCH/kieselstein-rest-docs
  artifacts:
    reports:
      coverage_report:
        coverage_format: cobertura
        path: cobertura.xml
    paths:
      - public
    expire_in: 30 days
  only:
    - develop
    - wildfly-26-java-11 # TODO [2024-08-01] ek: remove this when merging into develop

create-distpack:
  extends: .gradle-cache
  script:
    - $GRADLE clean
    - $GRADLE kieselstein-distpack:createDistpack
  artifacts:
    # name: "$CI_COMMIT_REF_NAME"
    expire_in: 1 week
    paths:
      - kieselstein-client/build/distributions
      - kieselstein-distpack/build/distributions
